#ifndef _ABCPLAYER_H_
#define _ABCPLAYER_H_

#include "player.h"
#include "song.h"

class AbcPlayer : public Player
{
    public:
        AbcPlayer();
        void parse(char const *s, int timestep);
        void parse(Song *s, int timestep);
        void clear();

        typedef enum PARSER_STATES
        {
            S_SKIP,
            S_NOTE,
            S_REST,
            S_LAST
        };

        typedef enum MODIFIERS
        {
            M_SHARP = 1,
            M_FLAT = (1 << 1),
            M_LOUD = (1 << 2),
            M_LAST
        };

        void prepare_for_playing();
        
    private:
        int note(int s);
        int modifier(int n);
        int end_time;
};


#endif

