#ifndef _BANK_H_
#define _BANK_H_
#include "synth.h"

#define NUM_VOICES 8

class Bank
{
    public:
        Bank(int num_tones, Synth const *basetone);
        ~Bank();

        void note_on(int note, double volume);
        void note_off(int note);
        void  update();
        int find_free_synth();

        void set_vibrato(int vibspeed, double vibdepth);

        int get_num_tones() const { return num_tones; };
        int note_pressed(int i) const { return (notemap[i] != 0);};

    private:
        double *tones;
        Synth **synths;
        int *notemap; // is the note being played (refcount)
        int *synthmap; // which synth is used byt this note?
        int num_tones;
        int vibtime, vibdepth;
};



#endif
