#ifndef _EVENTLIST_H_
#define _EVENTLIST_H_

#include "bank.h"

typedef struct EVENT
{
    int event;
    int data1;
    int data2;
    void *otherdata;
    int time;
    void (*callback)(int event, int data1, int data2, void *otherdata);
    EVENT *next;
    EVENT *prev;
} EVENT;

typedef enum EVENTS
{
    EVENT_NOTE_ON,
    EVENT_NOTE_OFF,
    EVENT_NOTIFY,
    EVENT_END_SONG,
    EVENT_LAST
};

class MainScreen;

class EventList
{
    public:
        EventList();
        void process();
        void add_event(int event, int time, int data1 = 0, int data2 = 0, void (*callback)(int,int,int, void *) = NULL, void *otherdata = NULL);
        void add_event(EVENT *e);
        void add_event_absolute(int event, int time, int data1 = 0, int data2 = 0, void (*callback)(int,int,int, void *) = NULL, void *otherdata = NULL);
        void add_event_absolute(EVENT *e);
        void set_bank(Bank *b);
        void set_mainscreen(MainScreen *m) { mains = m;};
    protected:
        static EVENT *freelist;
        EVENT *new_event();
        void delete_event(EVENT *e);
        void clear();
        Bank *b;

        void execute_event(EVENT *e);

        EVENT *list;
        EVENT *last;

    private:
        void insert_event(EVENT *e);
        void dumplist();
        static int installed_timer;
        MainScreen *mains;
        
};

extern void reset_timer();


#include "mainscreen.h"
#endif
