#include "jukebox.h"


JukeBox::JukeBox(SongCollection *_songs, EventList *output)
{
    player = new AbcPlayer();

    songs = _songs;
    player->set_output(output);
    speed = 100;

    cur_song = 0;
    player->parse(songs->get_song(cur_song), speed);

    playing = 0;
}

void JukeBox::next()
{
    player->stop();
    player->clear();

    cur_song++;
    if (cur_song >= songs->get_nr_songs())
        cur_song = 0;

    player->parse(songs->get_song(cur_song), speed);
    playing = 0;
}

void JukeBox::prev()
{
    player->stop();
    player->clear();

    cur_song--;
    if (cur_song < 0)
        cur_song = songs->get_nr_songs() - 1;

    player->parse(songs->get_song(cur_song), speed);
    playing = 0;
    

}
        
int JukeBox::get_nr_songs()
{
    ASSERT(songs);
    return songs->get_nr_songs();
}


char const *JukeBox::get_title(int i)
{
    return songs->get_song(i)->get_title();
}

