#ifndef _JUKEBOX_H_
#define _JUKEBOX_H_

#include "songs.h"
#include "abcplayer.h"

class JukeBox
{
    public:
        JukeBox(SongCollection *songs, EventList *output);
        int get_nr_songs();
        int get_cur_song() { return cur_song;};
        char const *get_title(int i);

        void play() { player->play(); playing = -1;};
        void stop() { player->stop(); playing = 0;};
        void next();
        void prev();
        int is_playing() { return playing;};
        
    private:
        AbcPlayer *player;
        SongCollection *songs;
        int cur_song;
        int speed;
        int playing;
        
};



#endif
