#include "utils.h"
#include "player.h"


static void repeater_callback(int ev, int d1, int d2, void *data)
{
    ASSERT(ev == EVENT_NOTIFY);
    
    Player *p = (Player *)data;

    if (d2 < -1)
        d2 = -1;

    if (d2 && !p->must_stop && d1 == p->eventcount)
        p->play(d2 - 1);
}


Player::Player()
{
    output = NULL;
    ready_to_play = 0;
    eventcount = 0;
}

void Player::set_output(EventList *o)
{
    output = o;
}

void Player::stop()
{
    must_stop = -1;
}

void Player::play(int repeat)
{
    EVENT *i = list;
    ASSERT(output);
    ASSERT(ready_to_play);

    eventcount++;
//    printf("play\n");
    must_stop = 0;


    
    while (i)
    {
  //   printf("add  %d  at time %d\n", i->event, i->time);

        if (i->event != EVENT_END_SONG)
            output->add_event(i);
        else
            output->add_event(EVENT_NOTIFY, i->time, eventcount, repeat - 1, repeater_callback, this);

        i = i->next;
    }

}


