#include <stdio.h>
#include "recorder.h"





Recorder::Recorder()
{
    locked = 0;

}


void Recorder::clear()
{
    stop();
    EventList::clear();
    locked = 0;
    ready_to_play = 0;
}

void Recorder::recording_finished()
{
    ASSERT(!locked);
    locked = 1;

    if (!list)
        return;

    ASSERT(!ready_to_play);
    
    int delta = list->time;

    add_event(EVENT_END_SONG, 0);

    EVENT *i = list;
    while (i)
    {
        i->time -= delta;
        i = i->next;
    }
    ready_to_play = -1;
    
}

void Recorder::note_on(int note, double volume)
{
    ASSERT(!locked);
    add_event(EVENT_NOTE_ON, 0, note, (int)(volume * 255));
}

void Recorder::note_off(int note)
{
    ASSERT(!locked);
    add_event(EVENT_NOTE_OFF, 0, note);
}


void Recorder::event(int e, int d1, int d2)
{
    ASSERT(!locked);
    add_event(e, 0, d1, d2);
}


int Recorder::has_recorded()
{
    if (list)
        return -1;

    return 0;
}
