#include <allegro.h>
#include "utils.h"
#include "song.h"


Song::Song(char *_title,  char **v, int s)
{
    voices = v;
    nr_voices = 0;
    while (v[nr_voices])
    {
        nr_voices++;
    }

    parts = NULL;

    speed = s;

    title = _title;
}

Song::Song(char *_title, int n, int s)
{
    nr_parts = n;
    parts = new Song *[nr_parts];

    title = _title;
    
    speed = s;

}

Song::~Song()
{
    if (parts)
        delete [] parts;
}


void Song::set_part(int part, Song *s)
{
    ASSERT(part >=0 && part < nr_parts);

    parts[part] = s;
}

int Song::get_nr_voices() const
{
    int i;
    if (!parts)
        return nr_voices;
        
    int ret = 0;

    for (i = 0; i< nr_parts;i++)
    {
        ret += parts[i]->get_nr_voices();
    }
    return ret;
}

char const *Song::get_voice(int v) const
{
    if (!parts)
        return voices[v];

    int i;

    for (i = 0; i< nr_parts;i++)
    {
        if (v < parts[i]->get_nr_voices())
            return parts[i]->get_voice(v);

        v -= parts[i]->get_nr_voices();
    }

    ASSERT(0);
    return NULL;
}


